#!/usr/bin/perl

$a = "/home/r/coderloop-test/reversesequence-a.in";
$b = "/home/r/coderloop-test/reversesequence-b.in";
$c = "/home/r/coderloop-test/reversesequence-c.in";

%test_map = ("a" => "b", "b" => "c");

sub create_map{
  ## creates a "linked map" from a string representing
  ## the input file.
  (my $file) = @_;
  my %map;
  open FILE, "<".$file or die $!;
  for (<FILE>){ chomp; /^(\w+)\W+(\w+)$/; $map{$1} = $2;}
  close FILE;
  return %map;}

sub find_beginning{
  ## takes a map representing a linked list and
  ## returns the beginning of that list.
  (my %map) = @_;
  my %val_set = map {$_ => 1} (values %map);
  my $start;
  foreach (keys %map){
    if (!($val_set{$_})){$start = $_;last}}
  return $start;}

sub trace_map{
  ## crawls through a map representing a linked-list
  ## and converts it into an actual array structure.
  (my %map) = @_;
  my $position = &find_beginning(%map);
  my @array = ($position);
  while(my $new_position = $map{$position}){
    push (@array, $new_position);
    $position = $new_position;}
  return @array;}



if (defined @ARGV){
  map {print;print"\n";} reverse(trace_map(create_map($ARGV[0])));}
