(ns coderloop.utils
  (:use [clojure.contrib
	 [shell-out :only [sh]]
	 [duck-streams :only [file-str read-lines copy]]])
  (:use [clojure [string :only [trim blank? split]]]))



  


(defn read-integer [file]
  (Integer/parseInt
   (trim (slurp (file-str file)))))
  
(defn read-big-integer [file]
  (java.math.BigInteger.
   (trim (slurp (file-str file)))))


(defn read-integer-line [#^java.lang.string s]
  (map #(Integer/parseInt %)
       (filter (comp not blank?)
	       (split s #"\W"))))


  
(defn read-integers
  "returns a lazy sequence of integers read from the file.
   Integers are delimited by any sort of whitespace"
  [#^java.io.File file]
  (mapcat read-integer-line
	  (filter (comp not blank?)
		  (read-lines (file-str file)))))
  

(defn trans-print [x]
  (println x )
  x)


(defn md5
  "given a string, compute the md5 checksum"
  [s]
  (let [t (java.io.File/createTempFile "zzz" "zzz")]
    (copy s t)
    (.deleteOnExit t)
      (sh "md5sum" (.getCanonicalPath t))))


(defn digits [n]
  (map #(Integer/parseInt (str %))  (seq (str n))))
